"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const path = __importStar(require("path"));
function compileBundleOptions(config) {
    return __awaiter(this, void 0, void 0, function* () {
        const f = config === undefined ? '.' : config;
        try {
            const file = typeof f === 'string' ? f : path.resolve('spack.config.js');
            let configFromFile = require(file);
            if (configFromFile.default) {
                configFromFile = configFromFile.default;
            }
            if (Array.isArray(configFromFile)) {
                if (Array.isArray(f)) {
                    return [...configFromFile, ...f];
                }
                if (typeof f !== 'string') {
                    configFromFile.push(f);
                }
                return configFromFile;
            }
            return Object.assign({}, configFromFile, config);
        }
        catch (e) {
            if (typeof f === 'string') {
                throw new Error(`Error occurred while loading config file at ${config}: ${e}`);
            }
            return f;
        }
    });
}
exports.compileBundleOptions = compileBundleOptions;
/**
 * Usage: In `spack.config.js` / `spack.config.ts`, you can utilize type annotations (to get autocompletions) like
 *
 * ```ts
 * import { config } from '@swc/core/spack';
 *
 * export default config({
 *      name: 'web',
 * });
 * ```
 *
 *
 *
 */
function config(c) {
    return c;
}
exports.config = config;
